import de.bezier.data.sql.*;

MySQL mysql;

ArrayList ckOut2006;
ArrayList ckOut2007;
ArrayList ckOut2008;
ArrayList ckOut2009;
ArrayList ckOut2010;
ArrayList ckOut2011;
ArrayList resultsArray;



/*
int ckOut2006 = ;
int ckOut2007 = 0;
int ckOut2008 = 0;
int ckOut2009 = 0;
int ckOut2010 = 0;
int ckOut2011 = 0;
*/
void setup()
{
  String user = "mat259";
  String pw = "V1sual1zat1on";

  String host = "tango.mat.ucsb.edu";
  String db =  "spl0";
  
  ckOut2006 = new ArrayList();
  ckOut2007 = new ArrayList();
  ckOut2008 = new ArrayList();
  ckOut2009 = new ArrayList();
  ckOut2010 = new ArrayList();
  ckOut2011 = new ArrayList();
  
  size(600, 800);
  
  mysql = new MySQL(this, host, db, user, pw);
  
  // Firearms Query
//  String query = "SELECT COUNT(DATE(cout)), DATE(cout) FROM inraw WHERE title like \"%gun%\" OR subj like \"%gun%\" GROUP BY DATE(cout) ORDER BY DATE(cout)";
  
  // Climate Change Query
  String query = "SELECT COUNT(DATE(cout)), DATE(cout) FROM inraw WHERE title like \"%climate%\" OR title like \"%environment%\"  OR subj like \"%environment%\" GROUP BY DATE(cout) ORDER BY DATE(cout)";
  println(query);
  
  resultsArray = new ArrayList();
  if (mysql.connect() )
  {
     int count = 0;
     mysql.query(query);
     while (mysql.next())
     {
       resultsArray.add(new DateCount(mysql.getInt(1), mysql.getString(2)));
     }
     
     for (int i = 0; i < resultsArray.size(); i++) {
        DateCount dc = (DateCount) resultsArray.get(i);
        if (dc.ckOutDate.getYear() == 2006) 
        { 
          ckOut2006.add(dc); 
        }
      
        else if (dc.ckOutDate.getYear() == 2007) 
        { 
          ckOut2007.add(dc);
        }
        else if (dc.ckOutDate.getYear() == 2008) 
        { 
          ckOut2008.add(dc);
        }
        else if (dc.ckOutDate.getYear() == 2009) 
        { 
          ckOut2009.add(dc);
        }
        else if (dc.ckOutDate.getYear() == 2010) 
        { 
          ckOut2010.add(dc);
        }
        else if (dc.ckOutDate.getYear() == 2011) 
        { 
          ckOut2011.add(dc);
        }
    }
  }
  else
  {
     println("Could not connect to database"); 
  }
}

void draw()
{
  background(50); 
  fill(255);
  DrawCircle("2006", ckOut2006, 100, 170);
  DrawCircle("2007", ckOut2007, 300, 100);
  DrawCircle("2008", ckOut2008, 125, 450);
  DrawCircle("2009", ckOut2009, 500, 505);
  DrawCircle("2010", ckOut2010, 500, 250);
  DrawCircle("2011", ckOut2011, 300, 375);

  textSize(30);
  fill(255);
  stroke(255);
  line(100, 650, 500, 650);
  // Firearm Text
//  text("Firearm Book Checkouts Over Time", 50, 700);

  // Environment Text
  text("Environment Book Checkouts Over Time", 5, 700);
  textSize(10);
  text("2006 Checkouts = " + ckOut2006.size(), 100, 725);
  text("2007 Checkouts = " + ckOut2007.size(), 100, 745);
  text("2008 Checkouts = " + ckOut2008.size(), 100, 765);
  text("2009 Checkouts = " + ckOut2009.size(), 400, 725);
  text("2010 Checkouts = " + ckOut2010.size(), 400, 745);
  text("2011 Checkouts = " + ckOut2011.size(), 400, 765);
  text("Total Checkouts = " + resultsArray.size(), 250, 785);
}

void DrawCircle(String strYear, ArrayList ckOutYear, int xPos, int yPos)
{
  fill(255);
  stroke(0);
  
  // Draw Circle
  int year_diameter = 100;
  float year_radius = year_diameter / 2;
  float circumf = PI * year_diameter;
  ellipse(xPos,yPos,year_diameter,year_diameter);
  // Write Year
  textSize(16);
  fill(155, 8, 10);
  text(strYear, xPos-18, yPos);
  
  // Write month
  textSize(8);
  text("Jan", xPos-5, yPos-year_diameter*.4);
  text("Mar", xPos+year_diameter*.35, yPos+5);
  text("Jun", xPos-5, yPos+year_diameter*.4);
  text("Sep", xPos-year_diameter*.45, yPos+5);

  // Do some initial calculations for the lines
  float lineWidth = circumf/ckOutYear.size();
  strokeWeight((int) round(lineWidth));
  float theta = TWO_PI / ckOutYear.size();

  // Set colors
  stroke(145);
  fill(40);
  
  // Prep for average
  int avgCount = 0;
  float avgTotal = 0;
  for (int p = 0; p < ckOutYear.size(); p++) {
    // Calculate positions
    float angle = p*theta; //calculate current angle
    float x = xPos+cos(angle-90) * year_radius; //calculate xPos
    float y = yPos+sin(angle-90) * year_radius; //calculate yPos
    float x2 = 0;
    float y2 = 0;

    // Need the height of the line to continue
    DateCount dc = (DateCount) ckOutYear.get(p);
    // Cut it down a bit...
    int lineHeight = dc.numCkOut / 2;

    // Calculate average
    avgTotal += dc.numCkOut;
    avgCount++;
    
    // For some reason you have to subtract 90 from the angle for it to work.
    x2 = x + lineHeight * cos(angle-90);
    y2 = y + lineHeight * sin(angle-90); 
    line(x, y, x2, y2); //draw line
 
  }
  float average = avgTotal/avgCount;
//  stroke(45, 95, 237);
  stroke(126, 126, 126);
  noFill();
  ellipse(xPos, yPos, year_diameter + average, year_diameter + average);
  
  
}
